using System;
using UnityEngine;
using UnityEngine.Events;
using System.Collections;
using System.Collections.Generic;

public class modperson : MonoBehaviour
{
    public PersonBehaviour PB;
    public float winceAmount;
    float timeUntilSeizure = 60f;
    public float brainDmgMultiplier;
    public float lungHealth = 1f, brainHealth = 1f, heartHealth = 1f, liverHealth = 1f;
    float maxBloodPressure;
    float maxConsciousness;
    public float lungHealthLossRate;

    void Awake()
    {
        PB = GetComponent<PersonBehaviour>();
    }
    void FixedUpdate()
    {
        if(brainDmgMultiplier > 0f && winceAmount <= 0)
        {
            timeUntilSeizure -= Time.deltaTime * brainDmgMultiplier;
        }
        if(timeUntilSeizure < 0f)
        {
            timeUntilSeizure = 60f;
            winceAmount = 6f;
        }
        if(winceAmount > 0f)
        {
            winceAmount -= Time.deltaTime;
            PB.OxygenLevel -= Time.deltaTime / 6f;
            PB.PainLevel = 1f;
            foreach (LimbBehaviour limb in PB.Limbs)
            {
                limb.Wince(750f);
            }
        }
    }
    void Update()
    {
        lungHealth -= lungHealthLossRate;
        PB.OxygenLevel -= (1f - lungHealth) * Time.deltaTime / 5f;

        maxConsciousness = 2f - brainDmgMultiplier;
        if(PB.Consciousness > maxConsciousness)
        {
            PB.Consciousness = maxConsciousness;
        }

        liverHealth += Time.deltaTime / 600f;
        if (liverHealth > 1f) liverHealth = 1f;
        if(liverHealth < 0.5f) //214, 201, 126
        {
            foreach (LimbBehaviour limb in PB.Limbs)
            {
                //limb.GetComponent<SpriteRenderer>().color = Color.Lerp(limb.GetComponent<SpriteRenderer>().color, new Color32(214, 201, 126, 255), 0.03f * Time.deltaTime);
                limb.Numbness += Time.deltaTime * 0.02f;
                limb.Health -= Time.deltaTime / 2f;
            }
        }

        maxBloodPressure = heartHealth + 1f / 2f;
        foreach (LimbBehaviour limb in PB.Limbs)
        {
            if(limb.GetComponent<CirculationBehaviour>().BloodFlow > maxBloodPressure)
            {
                limb.GetComponent<CirculationBehaviour>().BloodFlow = maxBloodPressure;
            }
        }
        if (PB.Consciousness < 1f)
        {
            PB.Consciousness += Time.deltaTime / 30f;
        }
        if(brainDmgMultiplier > 0.5f)
        {
            brainDmgMultiplier -= Time.deltaTime * 0.025f;
        }
        PB.OxygenLevel -= PB.ShockLevel / 8f * Time.deltaTime;
        if(PB.ShockLevel > 0.3f)
        {
            foreach (LimbBehaviour limb in PB.Limbs)
            {
                limb.Numbness += Time.deltaTime * 0.05f;
            }
        }
        if(PB.OxygenLevel <= 0f)
        {
            brainDmgMultiplier += Time.deltaTime * 0.03f;
        }
        if (heartHealth < 0f) heartHealth = 0f;
        if(heartHealth <= 0f)
        {
            PB.OxygenLevel -= Time.deltaTime / 5f;
            PB.PainLevel = 1f;
            foreach (LimbBehaviour limb in PB.Limbs)
            {
                limb.Numbness += Time.deltaTime * 0.08f;
                //limb.GetComponent<CirculationBehaviour>().BloodFlow = 0.3f;
            }
        }
    }
}
